<?php
if ('moneybookers-class.php' == basename($_SERVER['SCRIPT_FILENAME']))
     die ('<h2>Direct File Access Prohibited</h2>');
     
/*******************************************************************************
 *                      PHP Moneybookers IPN Integration Class
 *******************************************************************************
 *      Author:     L.Ch.Rajkumar
 *      Based on: Moneybookers class
 *      
 *      This class uses the basic version of Moneybookers Integration system
 *      into ESHOP WordPress Plugin's Merchant Gateway
 * 
 *******************************************************************************
*/
class moneybookers_class {
    
   var $last_error;                 // holds the last error encountered
   var $ipn_response;               // holds the IPN response from Moneybookers   
   var $ipn_data = array();         // array contains the POST values for IPN
   var $fields = array();           // array holds the fields to submit to Moneybookers
   
   function moneybookers_class() {
       
      // initialization constructor.  Called when class is created.
      $this->last_error = '';
      $this->ipn_response = '';
    
   }
   
   function add_field($field, $value) {
      
      // adds a key=>value pair to the fields array, which is what will be 
      // sent to moneybookers as POST variables.  If the value is already in the 
      // array, it will be overwritten.
      
      $this->fields["$field"] = $value;
   }

   function submit_moneybookers_post() {
      // The user will briefly see a message on the screen that reads:
      // "Please wait, your order is being processed..." and then immediately
      // is redirected to moneybookers.
      $echo= "<form method=\"post\" class=\"eshop eshop-confirm\" action=\"".$this->autoredirect."\"><div>\n";
	/*
	*
	* Grab the standard data
	*
	*/
      foreach ($this->fields as $name => $value) {
			$pos = strpos($name, 'amount');
			if ($pos === false) {
			   $echo.= "<input type=\"hidden\" name=\"$name\" value=\"$value\" />\n";
			}else{
				$echo .= eshopTaxCartFields($name,$value);
      	    }
      }
      	/*
	  	* Changes the standard text of the redirect page.
		*/
      $refid=uniqid(rand());
      $echo .= "<input type=\"hidden\" name=\"moneybookersoption1\" value=\"$refid\" />\n";
      $echo.='<label for="ppsubmit" class="finalize"><small>'.__('<strong>Note:</strong> Submit to finalize order at Moneybookers.','eshop').'</small><br />
      <input class="button submit2" type="submit" id="ppsubmit" name="ppsubmit" value="'.__('Proceed to Checkout &raquo;','eshop').'" /></label>';
	  $echo.="</div></form>\n";
      
      return $echo;
   }
	//function eshop_submit_moneybookers_post($_POST) {
        function eshop_submit_moneybookers_post() {
      // The user will briefly see a message on the screen that reads:
      // "Please wait, your order is being processed..." and then immediately
      // is redirected to moneybookers.
      
      	/*
	  	*
	  	* Grab the standard data, but adjust for your payment gateway as below
	  	* remember most fields will actually be hidden for POSTing to your gateway
	  	*
		*/
      
      global $eshopoptions, $blog_id;
      $moneybookers = $eshopoptions['moneybookers'];
		$echortn='<div id="process">
         <p><strong>'.__('Please wait, your order is being processed&#8230;','eshop').'</strong></p>
	     <p>'. __('If you are not automatically redirected to Moneybookers, please use the <em>Proceed to Moneybookers</em> button.','eshop').'</p>
         <form method="post" id="eshopgatmoneybookers" class="eshop" action="'.$this->moneybookers_url.'">
          <p>';
		$replace = array("&#039;","'", "\"","&quot;","&amp;","&");
		$moneybookers = $eshopoptions['moneybookers']; 
		
		/* your changes would replace this section: start*/
		
		$Cost=$_POST['amount'];
		if(isset($_POST['tax']))
			$Cost += $_POST['tax'];
		if(isset($_SESSION['shipping'.$blog_id]['tax'])) $Cost += $_SESSION['shipping'.$blog_id]['tax'];
		//$Cost = $Cost * 100;
		$desc = str_replace($replace, " ", $moneybookers['desc']);
                $Email = str_replace($replace," ", $moneybookers['email']);
                $Confirmation = str_replace($replace, " ", $moneybookers['confirmation']);
		$refid=$_POST['moneybookersoption1'];
		if($eshopoptions['status']!='live'){
			$moneybookers['id']='87654321';
		}
                 $language = "{$language}";
                 $amount = "{$amount}";
                 $text = "{$text}";
                 $State = $_POST['state'].''.$_POST['altstate'];
		$echortn.='
			<input type="hidden" name="pay_to_email" value="'.$Email. '" />
                        <input type="hidden" name="language" value="EN"/> 
                        <input type="hidden" name="amount" value="'.$Cost.'"/>   
                        <input type="hidden" name="currency" value="'.$eshopoptions['currency'].'"/>
                        <input type="hidden" name="detail1_description" value="'.$desc.'" />                 
			<input type="hidden" name="detail1_text" value="'.get_bloginfo('name').'" />
			<input type="hidden" name="confirmation_note" value="'.$Confirmation.'"/>
                        <input type="hidden" name="transaction_id" value="'.$refid.'"/>
                        <input type="hidden" name="status_url" value="'.$paystatus.'"/>
                        <input type="hidden" name="firstname" value="'.$_POST['first_name'].'"/>
                        <input type="hidden" name="lastname" value="'.$_POST['last_name'].'"/>
                        <input type="hidden" name="address" value="'.$_POST['address1'].'"/>
                        <input type="hidden" name="address2" value="'.$_POST['address2'].'"/>
                        <input type="hidden" name="city" value="'.$_POST['city'].'"/>
                        <input type="hidden" name="postal_code" value="'.$_POST['zip'].'"/>
                        <input type="hidden" name="phone_number" value="'.$_POST['phone'].'"/>
                        <input type="hidden" name="state" value="'.$State.'"/>
                        <input type="hidden" name="pay_from_email" value="'.$_POST['email'].'"/>    
                            
         <input class="button" type="submit" id="ppsubmit" name="ppsubmit" value="'. __('Proceed to moneybookers &raquo;','eshop').'" /></p>
	     </form>
	  </div>';
	  	/* your changes would replace this section :end	*/
		return $echortn;		
               
   }   
   function validate_ipn() {
      // generate the post string from the _POST vars aswell as load the
      // _POST vars into an arry so we can play with them from the calling
      // script.
      foreach ($_REQUEST as $field=>$value) { 
         $this->ipn_data["$field"] = $value;
      }
     
   }
}  
?>